package CH.psi.midas;

import javax.swing.*;
import java.awt.*;
import java.util.*;

public class MJHistVarDialog extends javax.swing.JDialog
{
	private Vector eventNames;
	private Vector eventVarNames;
    private Vector varSelection;

	public MJHistVarDialog(Frame parent)
	{
		super(parent, true);
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		setSize(516,277);
		setVisible(false);
		JLabel1.setText("Available variables:");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(12,108,168,24);
		JScrollPane1.setOpaque(true);
		getContentPane().add(JScrollPane1);
		JScrollPane1.setBounds(12,24,180,84);
		JScrollPane1.getViewport().add(JListEvents);
		JListEvents.setBounds(0,0,177,81);
		JScrollPane2.setOpaque(true);
		getContentPane().add(JScrollPane2);
		JScrollPane2.setBounds(12,132,180,132);
		JScrollPane2.getViewport().add(JListVars);
		JListVars.setBounds(0,0,177,129);
		JButtonAdd.setText("Add >>");
		JButtonAdd.setActionCommand("Add >>");
		getContentPane().add(JButtonAdd);
		JButtonAdd.setFont(new Font("Dialog", Font.PLAIN, 12));
		JButtonAdd.setBounds(204,144,108,24);
		JButtonRemove.setText("<< Remove");
		JButtonRemove.setActionCommand("<< Remove");
		getContentPane().add(JButtonRemove);
		JButtonRemove.setFont(new Font("Dialog", Font.PLAIN, 12));
		JButtonRemove.setBounds(204,180,108,24);
		JScrollPane3.setOpaque(true);
		getContentPane().add(JScrollPane3);
		JScrollPane3.setBounds(324,132,180,132);
		JScrollPane3.getViewport().add(JListSelection);
		JListSelection.setBounds(0,0,177,129);
		JLabel2.setText("Available events:");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(12,0,108,24);
		JButtonOK.setText("OK");
		JButtonOK.setActionCommand("OK");
		getContentPane().add(JButtonOK);
		JButtonOK.setBounds(408,12,96,24);
		JButtonCancel.setText("Cancel");
		JButtonCancel.setActionCommand("Cancel");
		getContentPane().add(JButtonCancel);
		JButtonCancel.setBounds(408,48,96,24);
		JLabel3.setText("Selected variables:");
		getContentPane().add(JLabel3);
		JLabel3.setBounds(324,108,168,24);
		setTitle("MJHistVarDialog");
		setModal(true);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		JButtonCancel.addActionListener(lSymAction);
		JButtonOK.addActionListener(lSymAction);
		SymListSelection lSymListSelection = new SymListSelection();
		JListEvents.addListSelectionListener(lSymListSelection);
		JButtonAdd.addActionListener(lSymAction);
		JButtonRemove.addActionListener(lSymAction);
		//}}
	}

	public void addNotify()
	{
        Dimension d = this.getSize();
		super.addNotify();

		// Adjust size according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
	}

	public MJHistVarDialog()
	{
		this((Frame)null);
		this.setTitle("Select variables");
		this.setLocation(100, 100);
	}
	
	public MJHistVarDialog(Vector eventNames, Vector eventVarNames, Vector varSelection)
	{
	    this();
	    this.eventNames = eventNames;
	    this.eventVarNames = eventVarNames;
	    this.varSelection = varSelection;
	    
	    // set initial selection
	    JListEvents.setListData(eventNames);
	    JListEvents.setSelectedIndex(0);
	    JListVars.setListData((Vector)eventVarNames.firstElement());
	    JListVars.setSelectedIndex(0);
	    JListSelection.setListData(varSelection);
	    JListSelection.setSelectedIndex(0);
	}

	static public void main (String args[])
	{
		(new MJHistVarDialog()).setVisible(true);
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == MJHistVarDialog.this)
				MJHistVarDialog_WindowClosing(event);
		}
	}

	void MJHistVarDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();
	}
	//{{DECLARE_CONTROLS
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JList JListEvents = new javax.swing.JList();
	javax.swing.JScrollPane JScrollPane2 = new javax.swing.JScrollPane();
	javax.swing.JList JListVars = new javax.swing.JList();
	javax.swing.JButton JButtonAdd = new javax.swing.JButton();
	javax.swing.JButton JButtonRemove = new javax.swing.JButton();
	javax.swing.JScrollPane JScrollPane3 = new javax.swing.JScrollPane();
	javax.swing.JList JListSelection = new javax.swing.JList();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JButton JButtonOK = new javax.swing.JButton();
	javax.swing.JButton JButtonCancel = new javax.swing.JButton();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == JButtonCancel)
				JButtonCancel_actionPerformed(event);
			else if (object == JButtonOK)
				JButtonOK_actionPerformed(event);
			else if (object == JButtonAdd)
				JButtonAdd_actionPerformed(event);
			else if (object == JButtonRemove)
				JButtonRemove_actionPerformed(event);
		}
	}

	void JButtonCancel_actionPerformed(java.awt.event.ActionEvent event)
	{
		returnValue = JOptionPane.CANCEL_OPTION;
		this.setVisible(false);
	}

	void JButtonOK_actionPerformed(java.awt.event.ActionEvent event)
	{
		returnValue = JOptionPane.CLOSED_OPTION;
		this.setVisible(false);
	}
	
	public int getReturnValue() {
	    return returnValue;
	}
	
	private int returnValue;

	class SymListSelection implements javax.swing.event.ListSelectionListener
	{
		public void valueChanged(javax.swing.event.ListSelectionEvent event)
		{
			Object object = event.getSource();
			if (object == JListEvents)
				JListEvents_valueChanged(event);
		}
	}

	void JListEvents_valueChanged(javax.swing.event.ListSelectionEvent event)
	{
		// get selection
		int i = JListEvents.getSelectedIndex();

	    // change variable vector
	    JListVars.setListData((Vector)eventVarNames.elementAt(i));
	    JListVars.setSelectedIndex(0);
	}
	
	void JButtonAdd_actionPerformed(java.awt.event.ActionEvent event)
	{
		int i = JListEvents.getSelectedIndex();
		int j = JListVars.getSelectedIndex();
		int k;
		
		if (i>=0 && j>=0) {
		  String s = eventNames.elementAt(i)+" / "+
		    ((Vector)eventVarNames.elementAt(i)).elementAt(j);
		    
		  // only add if not already there
		  for (k=0 ; k<varSelection.size() ; k++)  
		    if (((String)varSelection.elementAt(k)).equals(s))
		      break;
		  if (k == varSelection.size())
		    varSelection.addElement(s);
		    
		  JListSelection.setListData(varSelection);
		  
		  // Advance selection index in variable list
		  if (j < ((Vector)eventVarNames.elementAt(i)).size()-1)
		    JListVars.setSelectedIndex(j+1);
		}
			 
	}

	void JButtonRemove_actionPerformed(java.awt.event.ActionEvent event)
	{
		int i = JListSelection.getSelectedIndex();
		if (i>=0 && varSelection.size() > 0) {
		  varSelection.removeElementAt(i);
		  JListSelection.setListData(varSelection);
		  if (i == varSelection.size() && i>0)
		    JListSelection.setSelectedIndex(i-1);
		  else
		    JListSelection.setSelectedIndex(i);
		}
			 
	}
}