// -*- C++ -*-
//
// K2917.h
// Kinetics K2917 VME-CAMAC controler class
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Wed Jul  3 23:31:02 JST 2002
//
// $Id: K2917.h,v 1.1.1.1 2002/08/13 12:48:12 kensh Exp $
//
// Revision History
//
// $Log: K2917.h,v $
// Revision 1.1.1.1  2002/08/13 12:48:12  kensh
//
//
// Start version.
//
//

#ifndef  K2917_H_INCLUDED
#define  K2917_H_INCLUDED

// includes
#include <sys/vme.h>


//////
inline unsigned short
NAF( int n, int a, int f )
{
  return( ((n << 9) & 0xfe00) | ((a << 5) & 0x01e0) | (f & 0x001f) );
}


//////
typedef struct {
    unsigned short cser;
    unsigned short dummy02;
    unsigned short docr;
    unsigned short sccr;
    unsigned short dummy05;
    unsigned short mtc;
    unsigned short machi;
    unsigned short maclo;

    unsigned short dummy11;           /* 0x10 - 0x1F */
    unsigned short dummy12;
    unsigned short dummy13;
    unsigned short dummy14;
    unsigned short dummy15;
    unsigned short dummy16;
    unsigned short dummy17;
    unsigned short dummy18;

    unsigned short dummy21;           /* 0x20 - 0x2F */
    unsigned short dummy22;
    unsigned short dummy23;
    unsigned short dummy24;
    unsigned short dummy25;
    unsigned short dummy26;
    unsigned short dummy27;
    unsigned short dummy28;

    unsigned short dummy31;           /* 0x30 - 0x3F */
    unsigned short dummy32;
    unsigned short dummy33;
    unsigned short dummy34;
    unsigned short dummy35;
    unsigned short dummy36;
    unsigned short dummy37;
    unsigned short dummy38;

    unsigned short lamc;
    unsigned short donc;
    unsigned short empc;
    unsigned short aboc;
    unsigned short lamv;
    unsigned short donv;
    unsigned short empv;
    unsigned short abov;

    unsigned short dummy51;           /* 0x50 - 0x5F */
    unsigned short dummy52;
    unsigned short dummy53;
    unsigned short dummy54;
    unsigned short dummy55;
    unsigned short dummy56;
    unsigned short dummy57;
    unsigned short dummy58;

    unsigned short amr;
    unsigned short cmr;
    unsigned short cma;
    unsigned short cwc;
    unsigned short srr;
    unsigned short dlr;
    unsigned short dhr;
    unsigned short csr;
} K_REG;

typedef struct {
    char name[9];
    unsigned short cma;
    unsigned short wc;
} K_LIST;


//////
// constants


//////
class K2917 {
public:
  // constructor/destructor
  K2917();
  K2917( unsigned int baseaddr, int debugLevel=0 );
  ~K2917();
  // operator
  // static methods
  // methods
  void    camac_init();
  int     camac( unsigned short naf, unsigned int* data );

private:
  // static data
  // data
  int              m_debugLevel;
  int              m_fd16;
  unsigned int     m_baseaddr;
  unsigned int     m_mapsize;
  unsigned short*  m_mapbase;
  unsigned short*  m_map;  
  K_REG*           m_kreg;
  // methods
  bool    init( unsigned int baseaddr );
};

//
#endif // K2917_H_INCLUDED
