#!/usr/bin/perl

open( FH,"ccfortran.h" ) || die "cannot find ccfortran.h\n";
open( FC,"ccfortran.icc" ) || die "cannot find ccfortran.icc\n";

# Comment from ccfortran.h
while(<FH>){
    last if ( ! /\/\// );
    print $_;
}
print "\n";
print "#ifndef CCFORTRAN_H_INCLUDED\n";
print "#define CCFORTRAN_H_INCLUDED\n";
print "\n";
print "#include <list>\n";
print "#include <vector>\n";
print "#include <string>\n";
print "\n";
print "// Created from ccfortran.icc by ext_h.pl\n";
print "\n";

# Remove comment from ccfortran.icc
while(<FC>){
    last if ( ! /\/\// );
}

# Extract function declarations
$br = 0;
while(<FC>){
    if ( /\{/ ){
        $br++;
    }
    elsif ( /\}/ ){
        $br--;
    }
    elsif ( /CCFORTRAN_ICC_INCLUDED/ ){
        # skip
    }
    elsif ( $br == 0 ){
        if ( /\)/ ){
            chomp;
            print $_ . ";\n";
        }
        else{
            print $_;
        }
    }
}

print "\n";
print "#include \"ccfortran/ccfortran.icc\"\n";
print "\n";
print "#endif // CCFORTRAN_H_INCLUDED\n";
print "\n";
    
close( FC );
close( FH );
