// -*- C++ -*-
//
// DetParam.h
//
// Author:  Mitsuhiro YAMAGA
// Created: Tue Aug  6 09:22:10 JST 2002
//
// $Id: DetParam.h,v 1.2 2002/08/29 14:17:42 yamaga Exp $
//
// Revision History
//
// $Log: DetParam.h,v $
// Revision 1.2  2002/08/29 14:17:42  yamaga
// Conform to DB format.
//
// Revision 1.1.1.1  2002/08/13 12:48:13  kensh
//
//
// Start version.
//
//

#ifndef DETPARAM_H_INCLUDED
#define DETPARAM_H_INCLUDED

#include <iostream>
#include <list>
#include <string>

//
#define  MAX_NADCCRATE   2
#define  MAX_NADC       23
#define  MAX_NADCCH     96
#define  MAX_NTDCCRATE   2
#define  MAX_NTDC       23
#define  MAX_NTDCCH     64


// # det type subID ID ADCpa ADCsa TDCma TDCsa x y z HVcr HVsl HVch cable gain pedL pedH Tresol
typedef struct{
  std::string  name;
  std::string  type;
  std::string  cable;
  int          clusterID;
  int          ID;
  int          adcCrate;
  int          adcSlot;
  int          adcChannel;
  int          tdcCrate;
  int          tdcSlot;
  int          tdcChannel;
  double       x;
  double       y;
  double       z;
  double       hvCrate;
  double       hvSlot;
  double       hvChannel;
  double       gainL;
  double       pedestalL;
  double       pedWidthL;
  double       gainH;
  double       pedestalH;
  double       pedWidthH;
  double       time0;
  double       timeResol;
} E391_DETE_DB;


//
class DetParam{
public:
  // singleton
  static DetParam&  instance();
  //
  const std::list<E391_DETE_DB>&  paramList() const { return m_paramList; }
  const E391_DETE_DB*  db_adc( int crate, int slot, int ch ) const; // reverse index
  const E391_DETE_DB*  db_tdc( int crate, int slot, int ch ) const; // reverse index
  //
  bool  getDB( int runno );
  void  dumpDB() const;

protected:
  DetParam();
  ~DetParam();

private:
  // singleton
  static DetParam*  s_detparam;
  // data
  std::list<E391_DETE_DB>  m_paramList;
  E391_DETE_DB*  m_db_adc[MAX_NADCCRATE][MAX_NADC][MAX_NADCCH]; // reverse index
  E391_DETE_DB*  m_db_tdc[MAX_NTDCCRATE][MAX_NTDC][MAX_NTDCCH]; // reverse index
  // method
  void    makeReverseIndex();

};

//
#endif // DETPARAM_H_INCLUDED

